.TH BATTALION 1.3 "August 1996"
.SH NAME
battalion - a giant monster game
.SH SYNOPSIS
.B battalion
[
.B -alone
]
[
.B -backdrop
]
[
.B -detail
]
[
.B -music
]
[
.B -sound
]
[
.B -help
]
.SH DESCRIPTION
.I battalion
is a giant monster game where you are a giant monster
fighting to survive against the military while causing
as much destruction as you can.
.PP
You can choose to be one of four possible monsters: Googelon,
Techs, the Vapour or Flutter:
.PP
.RS 5
.IP Googelon 16
An idealistic young monster from Osaka bay heads off to America
to seek his fortune.

.IP Techs 16
A communications satellite gains consciousness while broadcasting a
Sam Peckinpah retrospective. After several more hours studying the
films of Sergio Leone and John Woo, Techs heads down to Earth, ready
to integrate into society.

.IP "the Vapour" 16
A dangerous experiment on a college campus goes terribly wrong an the
vapour escapes from a dorm room after a really excellent party.

.IP Flutter 16
A bug zapper is accidentally cross connected to the atomic pile of a 
nuclear reactor. A thunderous ZAP! The sky is filled with blue light ...
and something else.
.RS -5
.PP
Your sudden arrival caught the military off guard, but they're
on their way.
The military is equipped with Tanks, Rocket Launchers,
Maser-Tanks, Helicopters, Jet Fighters, and Bombers.
More powerful weapons are currently under
development and will be deployed against you when available.
And if the situation looks hopeless ...
.PP
Your current health is displayed in a coloured bar at the top left
corner of the screen. You lose energy when you move, activate your
weapon, or get hit. You slowly regenerate energy throughout the game.
When your energy runs out, you die and the game is over.
.PP
You get points for destroying military vehicles and buildings (but not
trees.)
.SH OPTIONS
.IP -alone 16
Battle without the aid of other monsters.
.PP
.IP  -backdrop 16
Run without the textual overlays, making
.I battalion
more suitable for use as a backdrop or a screensaver.
.PP
.IP -detail 16
Select the rendering quality from -1 (vector) to 0 (low) through 1 (med) to 2 (high).
The Mesa version of battalion defaults to level 0 and
the OpenGL version to level 1.
.IP  -music
Turn on the background music at startup.
.IP  -sound
Turn on sound effects at startup.
.IP  -help
Show a listing of the command line options.
.PP
.SH DEMO MODE
.I Battalion
starts out in demo mode, cycling through the monsters and
unleashing them upon a small unsuspecting town. The monsters aren't
very bright but demo mode will give you an idea what you are up
against. When you want to get in on the fun, press the spacebar.
You can then choose your monster and start senselessly destroying things.
.SH CONTROLS
The 1, 2, 3 keys control your view:
.RS 5
.TP 10
.SM 1
Monster view. You see the battlefield from the monster's point of view.
.TP 10
.SM 2
Overview. You see an overview of the battlefield. The i,j,k,l keys
rotate the battlefield in this view.
.TP 10
.SM 3
Army view. You see the battlefield from one of the military vehicles
attacking you.
.RS -5
.PP
The mouse and the arrow keys move the monster:
.RS 5
.TP 30
.SM Mouse forward/up arrow
moves monster forwards
.TP 30
.SM Mouse backward/down arrow
moves monster backwards
.TP 30
.SM Mouse right/right arrow
turns monster to its right
.TP 30
.SM Mouse forward/left arrow
turns monster to its left
.RS -5
.PP
The left mouse button and the 'ctrl' keys on the keyboard activate the
monster's weapon.
.PP
The 'a' and 'z' keys on the keyboard tilt the monster's head up and down.
.RS 5
.TP 20
.SM 'a' key
tilts the monster's head down
.TP 20
.SM 'z' key
tilts the monster's head up
.RS -5
.PP
You can resize/iconify the
.I battalion
window as you like. The game is paused while it is iconified.
.PP
The d (detail) key steps through the detail modes -1, 0, 1, and 2
(vector, low, medium, high), and can also be set at startup using the -d
option. Mode 1 is the default for the OpenGL version with mode 0 as the default
for the Mesa version. Mode -1 (vector) simulates what the game would look
like as a vector-graphics game. Mode 0 (low) removes some detail to
speed up the game. Mode 1 (medium) is the standard graphics mode.
Mode 2 (high) will make the graphics look better (with fog, transparent
explosions, and a bit of texture mapping.)
.PP
The h key activates displays the showcase help file (which contains
the same information as this man page, but with lots of pretty pictures.)
The game is temporarily halted while you are viewing help.
SGI version only. If you are running
.I battalion
on a Sun or with Linux then you can view the help files as individual GIFs
in the help directory.
.PP
The g key can be used to toggle pointer grabbing, which keeps the mouse
pointer inside the
.I battalion
window. 
.PP
The m key turns the background music on/off. Music will slow the game down
slightly; and I wouldn't recommend running any other sound-intensive
programs at the same time as
.I battalion.
The SunOS and Solaris versions of 
.I battalion
include very basic audio support.
.PP
The p key turns pause on/off. Pause freezes the action (you can't move,
and neither can the army) but the other controls (123,ijkl,dhmpsv)
are still active.
.PP
The s key turns the sound on/off. Sound will slow the game down slightly;
and I wouldn't recommend running any other sound-intensive programs at
the same time as
.I battalion.
The SunOS and Solaris versions of 
.I battalion
include very basic audio support.
.PP
The v key turns 3D video on/off. If you have a pair of 3D glasses
attached to your computer and a capable monitor you will see the
game in 3D. The size of the 3D area will match the size of your current
2D window, allowing you to speed up the 3D game by shrinking the size
of your window before invoking 3D video. SGI GL version only.
.PP
The high score file is kept in /usr/tmp/battalion_hiscore. If you wish to
use a different directory, you can set it using the BATTALIONSCOREDIR
environment variable.
.PP
If the environment variable BATTALIONSCOREUNIQUE is set, the number of high
score entries per user is limited to only one (the top entry).
.PP
The networking code allows multiple monsters to
collaboratively or competitively rampage through the same city. For a
collaborative session there is a single server and multiple clients
which can be started in any order. The server uses the -network parameter
to declare itslef a server and the -port #### to declare what port number
is being used (default is 6000.) The clients use the -client parameter
to delare themselves to be clients, -host <ip address> to give the
location of the host, and -port #### to match the server's port.
.PP
For example the server could be started as "battalionO -net -port 6000" on
machine akemi. A client wishing to join would be started
as "battalionO -client -host akemi -port 6000". The host machine IP address
can also be specified instead of its name.
SGI, Linux, Solaris and Sun versions only.
.PP
.SH DISCLAIMER
No giant monsters were harmed during the development of this game.
.SH AUTHOR
Andrew Johnson
